"Spray Client -> SoapOpera Server - 2002/5/22 Masashi Umezawa"
"Please see SoapExampleDoc >> howToRunExample"

methodNS := #'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/'.
"url := 'http://www.dolphinharbor.org/services/soapOperaInterop'." "url for Dolphinharbor Spray server"
url := 'http://localhost:8823/'. "url for your local SoapOpera server"

"'Display It' in workspace"
"1: call 'helloWorld' service"
request := SplashRPCRequest method: 'helloWorld' ns: methodNS .
response := request responseFrom: url soapAction: nil.
response return.

"2: call 'timeNow' service"
request := SplashRPCRequest method: 'timeNow' ns: methodNS .
response := request responseFrom: url soapAction: nil.
response return.

"3: call 'reverseString' service"
request := SplashRPCRequest method: 'reverseString' ns: methodNS .
request parameterAt: #aString put: 'Hello from Dolphin'.
response := request responseFrom: url soapAction: nil.
response return.

"4: call 'transcriptShow' service"
request := SplashRPCRequest method: 'transcriptShow' ns: methodNS .
request parameterAt: #aString put: ' <><> Hello from Dolphin at: ', Time now printString, ' <><>'.
response := request responseFrom: url soapAction: nil.
response return.

"5: call 'browseClassDefinition' service"
request := SplashRPCRequest method: 'browseClassDefinition' ns: methodNS .
request parameterAt: #className put: 'SoapExampleServiceImpl'. 
response := request responseFrom: url soapAction: nil.
response return asString.

"6: call 'reverseArray' service"
request := SplashRPCRequest method: 'reverseArray' ns: methodNS .
request parameterAt: #anArray put: #('Hello' 'from' 'Dolphin').
response := request responseFrom: url soapAction: nil.
response return.

"7: call 'returnComplexDictionary' service"
request := SplashRPCRequest method: 'returnComplexDictionary' ns: methodNS .
struct := XeQStruct new.
struct at: #Dolphin put: 'wonderful'.
request parameterAt: #aDictionary put: struct .
response := request responseFrom: url soapAction: nil.
response return.